namespace OptionsPattern.Sutdy.Advanced
{
    public class UseXunitTest:IDisposable
    {
        private readonly ITestOutputHelper? _output;
        public UseXunitTest(ITestOutputHelperAccessor outputHelperAccessor)
        {
            if (outputHelperAccessor == null)
            {
                throw new ArgumentNullException(nameof(outputHelperAccessor));
            }
            _output = outputHelperAccessor.Output;
        }

        
        /// <summary>
        /// xUnit Բ
        /// </summary>
        [Fact]
        public void UsabilityTest()
        {
            Assert.True(true, "6.2 ѡףʹxUnitԿܣ");
            _output?.WriteLine("6.2 ѡ ף");
        }

        /// <summary>
        /// Բ쳣
        /// ʹãxUnit ͨ
        /// </summary>
        [Fact]
        public void DoesNotThrow_Test()
        {
            //ִд
            Action codeSnippet = () =>
            {
                //ҵ

                //ģ쳣
                //throw new Exception("׳쳣");
            };

            var exception = Record.Exception(codeSnippet);
            Assert.Null(exception);

            _output?.WriteLine("ʹ xUnit ͨԲ쳣");
        }

        /// <summary>
        /// Բ쳣
        /// ʹãFluentAssertions ⷽʽԲ쳣
        /// </summary>
        [Fact]
        public void DoesNotThrow_UseFluentAssertions_Test()
        {
            //ִд
            Action codeSnippet= () =>
            {
                //ҵ

                //ģ쳣
                //throw new Exception("׳쳣");
            };

            //ԣ쳣
            codeSnippet.Should().NotThrow();

            _output?.WriteLine("ʹ FluentAssertions ⷽʽԲ쳣");
        }

        /// <summary>
        /// 
        /// </summary>
        public void Dispose()
        {
        }
    }
}